// KINEcpp.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
double CKineElements::totalmol=0;//S


double gP;//͋C
double gt;//ԍ
double gR;//ʋC̒萔
double gTMAX;//ő厞
double gT0;//x
double gCP=0.0;//舳M
double gQQH=0.0;//M


double gAK[4];
double gBK[4];
double gAAKR[4];
double gBBKR[4];
double gTime;
double gT;
double gTempMax;//ő剷x
double gTempMin;//Œቷx
int gisTchange;//xωl邩ǂ
int nOut;//o͐
int gnMAX;//őXebvB
int gnOunInterval;//o͊ԊuB

int gnTEntalPoin;
double gTental;
double gT0ental;
int gnTKpPoint;
double gTKp;
double gT0Kp;

wstring gOutputFileName;
int gisOverride;
vector<CKineElements> gvElements;
vector<CKineReaction> gvReaction;
void LoadCondition(const wstring& fname)//ݒǂݍށB
{
	CTextValueLoader cTvl;

    //ϐ`
    vector<wstring> vStrStr;
    vector<wstring> vIntStr;
    vector<wstring> vDoubleStr;

    //ʂ󂯎xN^[
    vector<wstring> vStr;
    vector<int> vInt;
    vector<double> vDouble;

    //ϐ`

	vStrStr.push_back(L"OutputFileName");
    //intϐ`
    vIntStr.push_back(L"isTchange");
    vIntStr.push_back(L"nOut");
    vIntStr.push_back(L"isOverride");

    //doubleϐ`
    vDoubleStr.push_back(L"P");
    vDoubleStr.push_back(L"R");
    vDoubleStr.push_back(L"t");
    vDoubleStr.push_back(L"TMAX");
    vDoubleStr.push_back(L"initTemp");

    //ϐݒ肵ĂB
    cTvl.SetStrStrVector(vStrStr);//ϐZbg֐
    cTvl.SetIntStrVector(vIntStr);//intϐZbg֐
    cTvl.SetDoubleStrVector(vDoubleStr);//doubleϐZbg֐

    try{
        cTvl.AnalizeInputFile(fname.data());
    }
    catch(...)
    {
        //G[ꍇAɏԁB
        //C++̗O
		cout << "ݒt@C̓ǂݍ݂Ɏs܂B\n";
        throw -1;
    }

    //vectorŕϊʂ󂯎B
    vStr    = cTvl.GetStrVector();
    vInt    = cTvl.GetIntVector();
    vDouble = cTvl.GetDoubleVector();

	gOutputFileName = vStr[0];


	gP   = vDouble[0];
	gR  = vDouble[1];
	gt = vDouble[2];
	gTMAX = vDouble[3];
	gT0  = vDouble[4];

	gisTchange = vInt[0];
	nOut = vInt[1];
	gisOverride = vInt[2];

	gnMAX = gTMAX/gt;
	gnOunInterval = gnMAX/nOut;

	gT = gT0;


	int hr;
    wchar_t afname[260];
    FILE *phfile;
    swprintf_s(afname , 260 , L"%s" , gOutputFileName.data());

    hr = _wmkdir(afname);
    if(gisOverride != 1)
    {
        for(int id=0; hr!=0 && id<20 ;id++)
        {
            swprintf_s(afname , 260 , L"%s%d" , gOutputFileName.data() , id);
            hr = _wmkdir(afname);
        }
        gOutputFileName = afname;
    }
    swprintf_s(afname , 260 , L"%s\\%s.txt" , gOutputFileName.data(), gOutputFileName.data());

    //݉\ǂ`FbNB
    _wfopen_s(&phfile , afname , L"wb");
    if(phfile == 0)
    {
        cout<<"o͗pfBNg̍쐬Ɏs\n";
        cout<<"t@Co͂ł܂\n";
        throw -1;
    }

    fclose(phfile);
    _wremove(afname);//eXgt@CזȂ̂ŏĂB


}

void LoadKINEDAT(const wstring& fname)
{
    int const TempStep      = ASM_USER+1;
    int const TempStart     = ASM_USER+2;
    int const TempSteplog   = ASM_USER+4;
    int const TempStartlog  = ASM_USER+5;
    int const elementBegin  = ASM_USER+6;
    int const ental   = ASM_USER+7;
    int const logkp   = ASM_USER+8;
	int const I_MINUS = ASM_USER+9;
	int const I_equal = ASM_USER+10;
	int const reaction = ASM_USER+11;

	//wavefrontobjt@Cǂݍ݂܂B
	CScriptAnalizer cas;
	INITIALIZE_INFO_DESC iid;
	__int64* pOPK[21];
	for(__int64 r=0;r<14;r++)
	{
		pOPK[r] = new __int64[6];
		for(int s=0;s<6;s++)
		{
			pOPK[r][s]=0;
		}
	}
	__wchar_t* pOP[20];
	pOP[0]  = _T(" ");
	pOP[1]  = _T("\"");
	pOP[2]  = _T("\r\n");
	pOP[3]  = _T("	");
	pOP[4]  = _T("-");
	pOP[5]  = _T("\uFEFF");
	pOP[6]  = _T("//");
	pOP[7]  = _T("/*");
	pOP[8]  = _T("*/");
	pOP[9]  = _T(",");
	pOP[10] = _T(";");
	pOP[11] = _T("+");
	pOP[12] = _T("=");
	pOP[13] = 0;

	pOPK[0][0]  = AS_SPACE_WORD;
	pOPK[1][0]  = AS_STRING_START;
	pOPK[1][1]  = AS_BLOCKWORD_ENTRY + 1;//ubN̑w肷B
	pOPK[1][2]  = AS_STRING_END;
	pOPK[2][0]  = AS_SPACE_WORD;
	pOPK[2][1]  = AS_ESCAPEBLOCK_END;
	pOPK[2][2]  = AS_WORDBREAK;
	pOPK[3][0]  = AS_SPACE_WORD;
	pOPK[4][0]  = AS_RESERVED_WORD;
	pOPK[5][0]  = AS_SPACE_WORD;
	pOPK[6][0]  = AS_ESCAPEBLOCK_START;
	pOPK[6][1]  = AS_BLOCKWORD_ENTRY + 2;
	pOPK[7][0]  = AS_ESCAPEBLOCK_START;
	pOPK[7][1]  = AS_BLOCKWORD_ENTRY + 8;
	pOPK[8][0]  = AS_ESCAPEBLOCK_END;
	pOPK[9][0]  = AS_SPACE_WORD;
	pOPK[10][0] = AS_OPERATION_END;
	pOPK[11][0] = AS_SPACE_WORD;
	pOPK[12][0] = AS_RESERVED_WORD;
	pOPK[13][0] = 0;

	__wchar_t* pOPC[14];
	pOPC[0] = _T("TempStep");
	pOPC[1] = _T("TempStart");
	pOPC[2] = _T("TempSteplog");
	pOPC[3] = _T("TempStartlog");
	pOPC[4] = _T("elementBegin");
	pOPC[5] = _T("ental");
	pOPC[6] = _T("logkp");
	pOPC[7] = _T("-");
	pOPC[8] = _T("=");
	pOPC[9] = _T("reaction");
    pOPC[10] = 0;

	__int64 pOPCK[15];
	pOPCK[0]  = TempStep;
	pOPCK[1]  = TempStart;
	pOPCK[2]  = TempSteplog;
	pOPCK[3]  = TempStartlog;
	pOPCK[4]  = elementBegin;
	pOPCK[5]  = ental;
	pOPCK[6]  = logkp;
	pOPCK[7]  = I_MINUS;
	pOPCK[8]  = I_equal;
	pOPCK[9]  = reaction;
    pOPCK[10] = 0;


	__wchar_t* pSTB[2];

	pSTB[0] = _T("\"");
	pSTB[1] = 0;

	iid.ppOperation = pOP;
	iid.ppOperationKind = pOPK;
	iid.asmEnableNumber = true;
	iid.asmEnableString = true;
	iid.Asd.nStrBlockSet = 1;
	iid.Asd.nTransSet    = 0;
	iid.Asd.pStrBlockStart = pSTB;
	iid.Asd.pStrBlockEnd   = pSTB;
	iid.Asd.pTransStr      = 0;
	iid.Asd.pTransToStr    = 0;
	
	cas.Init(&iid);
	for(__int64 r=0;pOPC[r]!=0;r++)
	{
		cas.AdAsmDistinction(pOPC[r] , pOPCK[r]);
	}

	//͊JnB
	ANALIZE_DESC ad;
	FILE *hfile;
	__int64 c;
	__int64 hr;
	__wchar_t *pcode;
	pcode = 0;
	_tfopen_s(&hfile , fname.data() , _T("rb"));
	if(hfile==0)
	{
		cout << "ݒt@C: Bound.txt J܂B\n";
		throw -1;
	}

	fseek(hfile , 0 ,  SEEK_END);
	c = ftell(hfile);
	fseek(hfile , 0 , SEEK_SET);

	c/=2;
	pcode = new __wchar_t[c+3];

	fread(pcode , sizeof(__wchar_t) , c , hfile);

	fclose(hfile);
	pcode[c+1] = 0;//NULLZbgĂB

	
	ad.pCode = pcode;
	ad.nCode = c;
	
	hr = cas.Analize(&ad);
	if(hr!=0)
	{
		_tprintf(cas.GetLastErr());
		throw -1;
	}

	//B
	EXE_ASMCODE_DESC ead;
	__int64 nr,nr2,nri;//ėpJE^
	double  dtemp,dtempa[5];//ꎞϐ
	CKineElements* pKEtemp=0;//GgNẌꎞۊǏꏊ
	CKineReaction* pKRtemp=0;//NẌꎞۊǏꏊ

	wstring wstr;
	gvElements.resize(0);
	gvReaction.resize(0);

	//}Ns܂B
	cas.AsmSetAssenblyPoint(0);//ǂݍ݃|CgZbgB
	
	for(int m0=0;true;m0++)
	{
		hr = cas.AsmGetNextAssembly(&ead);
		if(hr==1)
		{
			break;
		}
		if(hr!=0)
		{
			wcout << cas.GetLastErr();
			throw cas.GetLastErr();
		}

		switch (ead.kreg[0])
		{
		case TempStep:
			//lǂݍށB
			dtemp = 1;
			hr = 0;
			for(int j=1;j<ead.creg;j++)
			{
				switch (ead.kreg[j])
				{
				case ASM_IMM_DOUBLE:
				case ASM_IMM_INT:
					switch (ead.kreg[j])
					{
					case ASM_IMM_DOUBLE:
						dtemp *= *(double*)ead.reg[j];
						break;
					case ASM_IMM_INT:
						dtemp *= *(__int64*)ead.reg[j];
						break;
					}
					hr = 1;
					break;
				case I_MINUS:
					if(dtemp < 0)
					{
						cout<<ead.clum<<"s : -2dɂĂ܂B\n";
						throw -1;
					}
					dtemp *= -1;
					break;
				default:
					cout << ead.clum<<"s : TempStepɂ͐lw肵܂B \n";
					throw -1;
					break;
				}
			}
			if(hr != 1)
			{
				cout << ead.clum<<"s : TempStepɂ͐lw肵܂B \n";
				throw -1;
			}
			gTental = dtemp;
			break;
		case TempStart:
			dtemp = 1;
			hr = 0;
			for(int j=1;j<ead.creg;j++)
			{
				switch (ead.kreg[j])
				{
				case ASM_IMM_DOUBLE:
				case ASM_IMM_INT:
					switch (ead.kreg[j])
					{
					case ASM_IMM_DOUBLE:
						dtemp *= *(double*)ead.reg[j];
						break;
					case ASM_IMM_INT:
						dtemp *= *(__int64*)ead.reg[j];
						break;
					}
					hr = 1;
					break;
				case I_MINUS:
					if(dtemp < 0)
					{
						cout<<ead.clum<<"s : -2dɂĂ܂B\n";
						throw -1;
					}
					dtemp *= -1;
					break;
				default:
					cout << ead.clum<<"s : TempStartɂ͐lw肵܂B \n";
					throw -1;
					break;
				}
			}
			if(hr != 1)
			{
				cout << ead.clum<<"s : TempStartɂ͐lw肵܂B \n";
				throw -1;
			}
			
			gT0ental = dtemp;
			break;
		case TempSteplog:
			dtemp = 1;
			hr = 0;
			for(int j=1;j<ead.creg;j++)
			{
				switch (ead.kreg[j])
				{
				case ASM_IMM_DOUBLE:
				case ASM_IMM_INT:
					switch (ead.kreg[j])
					{
					case ASM_IMM_DOUBLE:
						dtemp *= *(double*)ead.reg[j];
						break;
					case ASM_IMM_INT:
						dtemp *= *(__int64*)ead.reg[j];
						break;
					}
					hr = 1;
					break;
				case I_MINUS:
					if(dtemp < 0)
					{
						cout<<ead.clum<<"s : -2dɂĂ܂B\n";
						throw -1;
					}
					dtemp *= -1;
					break;
				default:
					cout << ead.clum<<"s : TempSteplogɂ͐lw肵܂B \n";
					throw -1;
					break;
				}
			}
			if(hr != 1)
			{
				cout << ead.clum<<"s : TempSteplogɂ͐lw肵܂B \n";
				throw -1;
			}
			gTKp = dtemp;
			break;
		case TempStartlog:
			dtemp = 1;
			hr = 0;
			for(int j=1;j<ead.creg;j++)
			{
				switch (ead.kreg[j])
				{
				case ASM_IMM_DOUBLE:
				case ASM_IMM_INT:
					switch (ead.kreg[j])
					{
					case ASM_IMM_DOUBLE:
						dtemp *= *(double*)ead.reg[j];
						break;
					case ASM_IMM_INT:
						dtemp *= *(__int64*)ead.reg[j];
						break;
					}
					hr = 1;
					break;
				case I_MINUS:
					if(dtemp < 0)
					{
						cout<<ead.clum<<"s : -2dɂĂ܂B\n";
						throw -1;
					}
					dtemp *= -1;
					break;
				default:
					cout << ead.clum<<"s : TempStartlogɂ͐lw肵܂B \n";
					throw -1;
					break;
				}
			}
			if(hr != 1)
			{
				cout << ead.clum<<"s : TempStartlogɂ͐lw肵܂B \n";
				throw -1;
			}
			gT0Kp = dtemp;
			break;
		case elementBegin:
			if(pKEtemp != 0)
			{
				gvElements.push_back(*pKEtemp);
				delete pKEtemp;
				pKEtemp = 0;
			}
			//vf̋Lqn܂B
			pKEtemp = new CKineElements();
			
			wstr = ead.str[1];//w햼ƂĔFB
			//lǂݍށB


			nr = 0;
			dtempa[nr] = 1;
			for(int j=2;j<ead.creg;j++)
			{
				switch (ead.kreg[j])
				{
				case ASM_IMM_DOUBLE:
				case ASM_IMM_INT:
					switch (ead.kreg[j])
					{
					case ASM_IMM_DOUBLE:
						dtempa[nr] *= *(double*)ead.reg[j];
						break;
					case ASM_IMM_INT:
						dtempa[nr] *= *(__int64*)ead.reg[j];
						break;
					}
					nr++;
					dtempa[nr] = 1;
					break;
				case I_MINUS:
					if(dtempa[nr] < 0)
					{
						cout<<ead.clum<<"s : -2dɂĂ܂B\n";
						throw -1;
					}
					dtempa[nr] *= -1;
					break;
				default:
					cout << ead.clum<<"s : elementBegin ̑2-4͐lłЂ悤܂B\n";
					throw -1;
					break;
				}
			}
			if(nr != 3)
			{
				cout << ead.clum<<"s : elementBegin ɂ͐l3^Kv܂B\n";
				cout << ead.clum<<"s : elementBegin vf WG^s[  o͂邩ǂ\n";
				throw -1;
			}
			pKEtemp->m_elementsName = wstr;//w햼
			pKEtemp->m_Hi = dtempa[0];//WG^s[?
			pKEtemp->m_CF = dtempa[1];//
			pKEtemp->isOut = dtempa[2];//

			break;
		case ental:
			//G^s[ĂяoB
			if(pKEtemp == 0)
			{
				cout << "entalĂяȏOɁAelementBeginĂяoĂB\n";
				throw -1;
			}
			//G^s[̒li[ĂB
			dtemp = 1;
			for(int j=1;j<ead.creg;j++)
			{
				switch (ead.kreg[j])
				{
				case ASM_IMM_DOUBLE:
				case ASM_IMM_INT:
					
					switch (ead.kreg[j])
					{
					case ASM_IMM_DOUBLE:
						dtemp *= *(double*)ead.reg[j];
						break;
					case ASM_IMM_INT:
						dtemp *= *(__int64*)ead.reg[j];
						break;
					}

					pKEtemp->m_Entalphy.push_back(dtemp);
					dtemp = 1;

					break;
				case I_MINUS:
					if(dtemp < 0)
					{
						cout<<ead.clum<<"s : -2dɂĂ܂B\n";
						throw -1;
					}
					dtemp *= -1;
					break;
				default:
					cout << ead.clum<<"s : FȂltH[}bgłBentalɂ͐l̂ݎwł܂B\n";
					throw -1;
					break;
				}
			}
			break;
		case logkp:
			if(pKEtemp == 0)
			{
				cout << "logkpĂяȏOɁAelementBeginĂяoĂB\n";
				throw -1;
			}
			//Kp̒li[ĂB
			//G^s[̒li[ĂB
			hr = 0;
			dtemp = 1;
			for(int j=1;j<ead.creg;j++)
			{
				switch (ead.kreg[j])
				{
				case ASM_IMM_DOUBLE:
				case ASM_IMM_INT:
					switch (ead.kreg[j])
					{
					case ASM_IMM_DOUBLE:
						dtemp *= *(double*)ead.reg[j];
						break;
					case ASM_IMM_INT:
						dtemp *= *(__int64*)ead.reg[j];
						break;
					}
					pKEtemp->m_logKp.push_back(dtemp);
					dtemp = 1;
					break;
				case I_MINUS:
					if(dtemp < 0)
					{
						cout<<ead.clum<<"s : -2dɂĂ܂B\n";
						throw -1;
					}
					dtemp *= -1;
					break;
				default:
					cout << ead.clum<<"s : FȂltH[}bgłBlogkpɂ͐l̂ݎwł܂B\n";
					throw -1;
					break;
				}
			}
			break;
		case reaction:
			break;
		default:
			wcout<<ead.clum <<L"s : `Ȃʎq "<< ead.str[0]<<L" gp܂B\n";
			throw -1;
			break;
		}
	}
	if(pKEtemp != 0)
	{
		gvElements.push_back(*pKEtemp);
		delete pKEtemp;
		pKEtemp = 0;
	}
	cas.AsmSetAssenblyPoint(0);
	for(int m0=0;true;m0++)
	{
		hr = cas.AsmGetNextAssembly(&ead);
		if(hr==1)
		{
			break;
		}
		if(hr!=0)
		{
			wcout << cas.GetLastErr();
			throw cas.GetLastErr();
		}

		switch (ead.kreg[0])
		{
		case reaction://ǂݍ݁B
			//O3͐lłKvB
			pKRtemp = new CKineReaction();
			nr = 0;
			nr2 = 0;
			dtempa[nr] = 1;
			for(int j=1;j<ead.creg;j++)
			{
				switch (ead.kreg[j])
				{
				case ASM_IMM_DOUBLE:
				case ASM_IMM_INT:
					switch (ead.kreg[j])
					{
					case ASM_IMM_DOUBLE:
						dtempa[nr] *= *(double*)ead.reg[j];
						break;
					case ASM_IMM_INT:
						dtempa[nr] *= *(__int64*)ead.reg[j];
						break;
					}
					nr++;
					dtempa[nr] = 1;
					break;
				case I_MINUS:
					if(dtempa[nr] < 0)
					{
						cout<<ead.clum<<"s : -2dɂĂ܂B\n";
						throw -1;
					}
					dtempa[nr] *= -1;
					break;
				default:
					cout << ead.clum<<"s : reaction ̑1-3͐lłKv܂B\n";
					throw -1;
					break;
				}
				if(nr == 3)
				{
					nr2 = j;
					break;
				}
			}
			if(nr != 3)
			{
				cout << ead.clum<<"s : reaction ɂ͐l3^Kv܂B\n";
				throw -1;
			}
			pKRtemp->m_rac = dtempa[0];
			pKRtemp->m_rae = -dtempa[1]/1.98726;
			pKRtemp->m_rat = dtempa[2];

			//ǂݍށB
			hr = 1;
			nri = 1;
			for(int j=nr2+1;j<ead.creg;j++)
			{
				switch (ead.kreg[j])
				{
				case ASM_IMM_INT:
				case ASM_IMM_DOUBLE:
					//l͖B
					break;
				case I_MINUS:
					nri *= -1;
					break;
				case I_equal:
					//ւB
					if(hr == -1)
					{
						cout << ead.creg << "s : reaction ɓ2ȏgĂ܂B\n";
						throw -1;
					}
					hr *= -1;
					nri = hr;
					break;
				default:
					//ϐƂĔFB
					//Ή鉻w킪邩ǂmFB
					wstr = ead.str[j];
					nr = -1;
					for(int k = 0;k<gvElements.size();k++)
					{
						if(wstr == gvElements[k].m_elementsName)
						{
							nr = k;
							break;
						}
					}
					if(nr == -1)
					{
						wcout <<ead.clum <<"s : reaction w "<< wstr << " ͒`Ă܂B\nelementBeginpĉw`Ă\n";
						throw -1;
					}

					//Y鉻w𔭌B
					if(nri == 1)
					{
						//
						pKRtemp->m_Nleft.push_back(nr);
					}
					else
					{
						pKRtemp->m_Nright.push_back(nr);
					}

					nri = hr;//̑Oŕ𔽓]B
					break;
				}
			}
			gvReaction.push_back(*pKRtemp);
			delete pKRtemp;
			pKRtemp = 0;
			break;
		default:
			break;
		}
	}

	//x`_̒

	nri = 200000;
	nr  = 200000;

	for(int i=0;i<gvElements.size();i++)
	{
		if(nri > gvElements[i].m_Entalphy.size())
		{
			nri = gvElements[i].m_Entalphy.size();
		}
		if(nr > gvElements[i].m_logKp.size())
		{
			nr = gvElements[i].m_logKp.size();
		}
	}
	gnTEntalPoin = nri;
	gnTKpPoint = nr;

	dtemp    = (gnTEntalPoin-1)*gTental + gT0ental;
	gTempMax = (gnTKpPoint-1)*gTKp + gT0Kp;

	if(dtemp > gTempMax)
	{
		gTempMax = dtemp;
	}

	gTempMin = gT0ental;
	if(gTempMin < gT0Kp)
	{
		gTempMin = gT0Kp;
	}
	//
	dtemp = 0;
	for(int i=0;i<gvElements.size();i++)
	{
		dtemp += gvElements[i].m_CF;
	}

	CKineElements::totalmol = gP/(gT*gR);

	for(int i=0;i<gvElements.size();i++)
	{
		gvElements[i].m_CF = gvElements[i].m_CF/dtemp;
		gvElements[i].m_CM = gvElements[i].totalmol*gvElements[i].m_CF;
	}
}
void begin()
{
      int nKp;
	  int nEnt;
	  double cp1,cp3,cn1,cn3;
	  for(int i=0;i<gvElements.size();i++)
	  {
		  nKp = gvElements[i].m_logKp.size()-3;

		  for(int k=0;k<nKp;k++)
		  {
			  cp1 = (gvElements[i].m_logKp[k+2]+gvElements[i].m_logKp[k+1])/2;
			  cp3 = (gvElements[i].m_logKp[k+3]+gvElements[i].m_logKp[k])/2;
			  cn1 = (gvElements[i].m_logKp[k+2]-gvElements[i].m_logKp[k+1])/2;
			  cn3 = (gvElements[i].m_logKp[k+3]-gvElements[i].m_logKp[k])/2;

			  gvElements[i].KpCoeA.push_back((cn3-3*cn1)/24);
			  gvElements[i].KpCoeB.push_back((cp3-cp1)/8);
			  gvElements[i].KpCoeC.push_back((27*cn1-cn3)/24);
			  gvElements[i].KpCoeD.push_back((9*cp1-cp3)/8);
		  }
	  }
	  for(int i=0;i<gvElements.size();i++)
	  {
		  for(int j=0;j<gvElements[i].m_Entalphy.size();j++)
		  {
			  cp3 = (gvElements[i].m_Entalphy[j]+gvElements[i].m_Hi)*1000;
			  gvElements[i].m_AbsEntalphy.push_back(cp3);
		  }
	  }

	  for(int i=0;i<gvElements.size();i++)
	  {
	      nEnt = gvElements[i].m_Entalphy.size()-3;
		  for(int j=0;j<nEnt;j++)
		  {
			  cp1=(gvElements[i].m_AbsEntalphy[j+2]+gvElements[i].m_AbsEntalphy[j+1])/2;
			  cp3=(gvElements[i].m_AbsEntalphy[j+3]+gvElements[i].m_AbsEntalphy[j])/2;
			  cn1=(gvElements[i].m_AbsEntalphy[j+2]-gvElements[i].m_AbsEntalphy[j+1])/2;
			  cn3=(gvElements[i].m_AbsEntalphy[j+3]-gvElements[i].m_AbsEntalphy[j])/2;

			  gvElements[i].EntalCoeA.push_back((   cn3 -3*cn1)/24);
			  gvElements[i].EntalCoeB.push_back((   cp3 -  cp1)/8 );
			  gvElements[i].EntalCoeC.push_back((27*cn1 -  cn3)/24);
			  gvElements[i].EntalCoeD.push_back((9 *cp1 -  cp3)/8 );
		  }
	  }

	  int nib;
	  for(int i=0;i<gvElements.size();i++)
	  {
		  nib = 0;
		  for(int j=0;j<gvReaction.size();j++)
		  {
			  for(int k=0;k<gvReaction[j].m_Nleft.size();k++)
			  {
				  if(gvReaction[j].m_Nleft[k] == i)
				  {
				      gvElements[i].indLeft.push_back(j);
				  }
			  }
			  for(int k=0;k<gvReaction[j].m_Nright.size();k++)
			  {
				  if(gvReaction[j].m_Nright[k] == i)
				  {
				      gvElements[i].indRight.push_back(j);
				  }
			  }
		  }
	  }
}
void ental()
{
	int NT=(gT - gT0ental)/gTental;
    double TR=(double)NT*gTental+gT0ental+gTental/2;
    double X=(gT-TR)/(gTental/2);

    double XCV=0.0;

	double H;
	double hA,hB,hC,hD;//⊮֐̌W
	double mdot,fc;

	gCP  = 0;
	gQQH = 0;
	for(int i=0;i<gvElements.size();i++)
	{
		hA = gvElements[i].EntalCoeA[NT];
		hB = gvElements[i].EntalCoeB[NT];
		hC = gvElements[i].EntalCoeC[NT];
		hD = gvElements[i].EntalCoeD[NT];


		mdot = gvElements[i].mdot;
		fc   = gvElements[i].m_CF;

		H    = ( hA *X*X*X + hB*X*X + hC*X+hD);
		gQQH = gQQH + H*mdot;
		XCV  = (3*hA*X*X + 2*hB*X + hC)/(gTental/2);
		gCP  =  gCP  + XCV*fc;

	}
}
void rate()
{
	for(int j=0;j<gvReaction.size();j++)
	{
		gvReaction[j].m_RFowrd = gvReaction[j].m_rac*pow(gT , gvReaction[j].m_rat)*exp(gvReaction[j].m_rae/gT);
	}

    int NT = (gT - gT0Kp)/gTKp;
	double TR = NT*gTKp + gT0Kp + gTKp/2;

    double x=(gT-TR)/(gTKp/2);

	double akp,bkp,ckp,dkp;
	for(int i=0;i<gvElements.size();i++)
	{
		akp = gvElements[i].KpCoeA[NT];
		bkp = gvElements[i].KpCoeB[NT];
		ckp = gvElements[i].KpCoeC[NT];
		dkp = gvElements[i].KpCoeD[NT];
		gvElements[i].ckt = akp*x*x*x + bkp*x*x + ckp*x + dkp;
	}

	double ck_left;
	double ck_right;
	double ck;
	double ckpe;
	int i;
	int nElements;
	for(int j=0;j<gvReaction.size();j++)
	{
		ck_left=0;
		
		ck_right=0;
		for(int k=0;k<gvReaction[j].m_Nleft.size();k++)
		{
			i = gvReaction[j].m_Nleft[k];
			ck_left=ck_left-gvElements[i].ckt;

			if(ck_left > 35)
				ck_left = 35;

		}
		for(int k=0;k<gvReaction[j].m_Nright.size();k++)
		{
			i = gvReaction[j].m_Nright[k];
			ck_right = ck_right - gvElements[i].ckt;
			if(ck_right > 35)
				ck_right = 35;
		}

		ck = ck_left-ck_right;

		if(ck > 35)
			ck = 35;

		nElements = gvReaction[j].m_Nleft.size() - gvReaction[j].m_Nright.size();

		ckpe = pow(10 , ck);

		ckpe=ckpe*pow(gR*gT/gP , nElements);

		gvReaction[j].m_RReverse = gvReaction[j].m_RFowrd/ckpe;
	}
	int ni;//ɗp鉻wւ̃CfbNX

	double fRa;//ւ̔x
	double rRa;//tւ̔x

	for(int j=0;j<gvReaction.size();j++)
	{	
		fRa = gvReaction[j].m_RFowrd;
		for(int k=0;k<gvReaction[j].m_Nleft.size();k++)
		{
			ni = gvReaction[j].m_Nleft[k];

			fRa *= gvElements[ni].m_CM;
		}
		
		rRa = gvReaction[j].m_RReverse;
		for(int k=0;k<gvReaction[j].m_Nright.size();k++)
		{
			ni = gvReaction[j].m_Nright[k];

			rRa *= gvElements[ni].m_CM;
		}
		
		gvReaction[j].FowrdReactSpeed = fRa - rRa;
	}
}
void Init()
{
	try{
		LoadCondition(L"Condition.txt");
	}
	catch(...)
	{
		wcout << L"Condition.txt ǂݍݒɗO\n";
		throw -1;
	}
	try{
		LoadKINEDAT(L"KINEDAT.txt");
	}
	catch(...)
	{
		wcout << L"KINEDAT.txt ǂݍݒɗO\n";
		throw -1;
	}
	if(gT0 < gT0ental || gT0 < gT0Kp )
	{
		cout <<"x" << gT0 << "x֐̍ŏl entalTmin"<<gT0ental << "@kpTmin"<<gT0Kp<<" Ă܂B\n";
		throw -1;
	}
	begin();

	gAK[0] = 0.5;
	gAK[1] = 1 - sqrt(0.5);
	gAK[2] = 1 + sqrt(0.5);
	gAK[3] = 0.5;

	gBK[0] = 3.0;
	gBK[1] = 3.0;
	gBK[2] = 3.0;
	gBK[3] = 3.0;

	gAAKR[0] = 2.0;
	gAAKR[1] = 1.0;
	gAAKR[2] = 1.0;
	gAAKR[3] = 2.0;

	gBBKR[0] = 0.5;
	gBBKR[1] = 1 - sqrt(0.5);
	gBBKR[2] = 1 + sqrt(0.5);
	gBBKR[3] = 0.5;
}
void output(int nc)
{
	cout << nc << "Ԗڂ̏o\n";
	wchar_t fname[260];
	FILE *hfile;
	if(nc == 0)
	{
		//vZo͂B
		swprintf_s(fname , L"%s\\%s.txt" , gOutputFileName.data() , gOutputFileName.data());

		hfile = _wfopen(fname , L"w");
		if(hfile == 0)
		{
			wcout << "t@CA"<<fname <<" J܂B\n";
			throw -1;
		}
		fwprintf(hfile , L"vZt@C\n\nvOo[Wv1.0.0 \n2014/7/20 by Tagawa Lab\n\n" );
		fwprintf(hfile , L"x = %g[K]\n͋C = %g[atm]\nw퐔 = %d\r\n = %d\n"
			,gT0 , gP , gvElements.size() , gvReaction.size());
		fwprintf(hfile , L"ʋC̒萔 = %g[atm*cm^3/mol K]\nԍ = %g[s]\n"
			,gR , gt);
		fwprintf(hfile , L"G^s[x`_ = %d\nt萔̏pΐx`_ = %d\n"
			,gnTEntalPoin , gnTKpPoint);
		
		fwprintf(hfile , L"ő剷x = %g[K]\nŒቷx = %g[K]\n"
			,gTempMax , gTempMin);
		fclose(hfile);
	}

	//߂Ɍ̃f[^JB		
	swprintf_s(fname , L"%s\\%s.csv" , gOutputFileName.data() , gOutputFileName.data());
	if(nc == 0)
	{
		_wfopen_s(&hfile , fname , L"w");
		if(hfile == 0)
		{
			wcout << "t@CA"<<fname <<" J܂B\n";
			throw -1;
		}
		//wb_ށB
		fwprintf(hfile , L"[ms],x[K]" );
		for(int i=0;i<gvElements.size();i++)
		{
			if(gvElements[i].isOut == 1)
			{
				fwprintf(hfile , L",%s[ppm]",gvElements[i].m_elementsName.data());
			}
		}
		fwprintf(hfile , L"\n" );
	}
	else
	{
		_wfopen_s(&hfile , fname , L"a");
		if(hfile == 0)
		{
			wcout << "t@CA"<<fname <<" J܂B\n";
			throw -1;
		}
	}
	fwprintf(hfile , L"%3.5e,%3.5e",gTime*1e3,gT);
	for(int i=0;i<gvElements.size();i++)
	{
		if(gvElements[i].isOut == 1)
		{
			fwprintf(hfile , L",%3.5e",gvElements[i].m_CF*1e6);
		}
	}
	fwprintf(hfile , L"\n" );
	fclose(hfile);

}

int _tmain(int argc, _TCHAR* argv[])

{
	try{
		setlocale(LC_ALL , "JPN");
		//t@C̓ǂݍ݁B
		Init();

		//C[v
		int ia;
		int nright,nleft;//ӁAEӂ̉w̐B
		double tQ;
		double dk,Qk,cm,cmN,QkN;
		double Tk,TkN;

		double dTotalMol;
		gTime = 0;
		for(int nc=0;nc<=gnMAX;nc++)
		{
			if(nc%gnOunInterval == 0)
			{
				output(nc/gnOunInterval);
			}

			if(nc == gnMAX)
				break;

			rate();
			CKineElements::totalmol = gP/(gT*gR);

			for(int i=0;i<gvElements.size();i++)
			{
				//react̎
				nleft  = gvElements[i].indLeft.size();
				nright = gvElements[i].indRight.size();

				tQ = 0;
				for(int j=0;j<nleft;j++)
				{
					ia = gvElements[i].indLeft[j];
					tQ += -gvReaction[ia].FowrdReactSpeed;
				}
				for(int j=0;j<nright;j++)
				{
					ia = gvElements[i].indRight[j];
					tQ += gvReaction[ia].FowrdReactSpeed;
				}
				gvElements[i].mdot = tQ;
				//reactI
			}
			//QNb^[v
		
			for(int i=0;i<gvElements.size();i++)
			{
				Qk = 0;
				cm = gvElements[i].m_CM;
				dk = gvElements[i].mdot*gt;

				for(int cRk=0;cRk<4;cRk++)
				{
					cmN = cm + gAK[cRk]*(dk - gAAKR[cRk] * Qk);
					QkN = Qk + gBK[cRk]*(cmN - cm) - gBBKR[cRk]*dk;

					if(cmN < 0)
					{
						cmN = 0;
					}
					if(cmN > CKineElements::totalmol)
					{
						cmN = CKineElements::totalmol;
					}
					cm = cmN;
					Qk = QkN;
				}

				gvElements[i].m_CM = cm;
			}
			if(gisTchange != 0)
			{
				ental();
				Qk = 0;
				dk = -gQQH/CKineElements::totalmol/gCP*gt;

				Tk = gT;
				for(int cRk=0;cRk<4;cRk++)
				{
					TkN = Tk + gAK[cRk]*(dk - gAAKR[cRk]*Qk);
					QkN = Qk + gBK[cRk]*(TkN - Tk) - gBBKR[cRk]*dk;

					if(TkN > gTempMax)
					{
						cout << "xő剷x"<< gTempMax<<"x𒴂܂\n";
						TkN = gTempMax;
					}
					if(TkN < gTempMin)
					{
						cout << "xŒቷx"<< gTempMin<<"x܂܂B\n";
						TkN = gTempMin;
					}
					Tk = TkN;
					Qk = QkN;
				}

				gT = Tk;
			}
			else
			{
				gQQH = 0;
			}

			CKineElements::totalmol = gP/(gT*gR);
			//vZ
			dTotalMol = 0;
			for(int i=0;i<gvElements.size();i++)
			{
				dTotalMol += gvElements[i].m_CM;
			}
			for(int i=0;i<gvElements.size();i++)
			{
				gvElements[i].m_CF = gvElements[i].m_CM/dTotalMol;
				gvElements[i].m_CM = gvElements[i].m_CF*CKineElements::totalmol;
			}

			gTime += gt;

		
		}
	}
	catch(...)
	{
		cout << "O܂BvOI܂B\n";
		system("PAUSE");
		return -1;
	}
	return 0;
}


