#include "ScriptAnalizer.h"
#include <math.h>
#include <string.h>
#include <stdio.h>
#include "stdafx.h"
//Version 3.2.0 2013/9/27
CScriptAnalizer::CScriptAnalizer(void)
{
	m_isInit = false;
	m_ppOpeStrKind = 0;
	m_pOpeStr    = 0;

	m_pOpeStr=0;//߂̕ւ̔z
	m_pOpeLen=0;//߂̕B
	m_ppOpeStrKind=0;//߂̎
	m_pOrgOpeMap=0;
	m_pOpeMap = 0;

	swprintf_s(m_errmsg , 200 , L"Unknown or No err");

	m_isInit=0;
    m_pAsmCode=0;
	m_nAsmCode=0;
	m_cAsm = 0;

	m_pDistStr = 0;
	m_pDistLength = 0;
	m_phDist = 0;
	m_cDistSize   = 0;
	m_cDist = 0;

	m_isNum = false;
	m_isStr = false;
	m_isCompile = false;
	m_pStringStart = 0;
	m_pStringEnd  = 0;

	m_pTransStr = 0;
	m_pTransToStr  =0;
	m_MaxLenTransStr=0;

	m_pAsmStrBuff = 0;
	m_cAsmStrBuff = 0;
	m_nAsmStrBuff = 0;
	m_AsmStrBuffcAsmIndex=0;
	m_AsmStrBuffStrIndex=0;
}
__int64 CScriptAnalizer::Init(INITIALIZE_INFO_DESC* pdesc)
{
	__int64 hr;
	__int64 slen;
	__int64* pPriMap;
	__int64* pOpeLen;
	__int64 nOpe;
	
	for(nOpe=0;pdesc->ppOperation[nOpe] != 0;nOpe++);

	nOpe++;
	m_pOpeStr      = new wchar_t*[nOpe];
	m_ppOpeStrKind  = new __int64*[nOpe];

	pPriMap            = new __int64[nOpe];
	pOpeLen            = new __int64[nOpe];
	m_pOpeLen = new __int64[nOpe];
	m_pOrgOpeMap       = new __int64[nOpe];
	m_pOpeMap          = new __int64[nOpe];
	nOpe--;
	
	memset(pPriMap , 0 ,  sizeof(__int64)*nOpe);

	__int64 x;
	//D}bvB傫Ƀ\[gB
	//łɕ̒擾ĂB
	for(__int64 r=0 ; pdesc->ppOperation[r]!=0 ; r++)
	{
		slen = wcslen(pdesc->ppOperation[r]);
		pOpeLen[r] = slen;
		for(x=r-1;x>=0;x--)
		{
			if(slen < pOpeLen[pPriMap[x]])
			{
				//ԂւB
				memcpy(pPriMap + x + 2 , pPriMap + x+1 , sizeof(__int64)*(r -x-1));
				pPriMap[x+1] = r;
				break;
			}
		}
		if(x == -1)//Ō܂ōsBĈԑ傫B
		{
			memcpy(pPriMap + 1 , pPriMap , sizeof(__int64)*r);
			pPriMap[0] = r;
		}
	}

	for(__int64 r=0;pdesc->ppOperation[r]!=0;r++)
	{
		hr = pPriMap[r];
		slen = pOpeLen[hr];
		slen ++;
		m_pOpeStr[r] = new wchar_t[slen];//mہB
		memcpy(m_pOpeStr[r] , pdesc->ppOperation[hr] , sizeof(wchar_t)*slen);

		for(slen=0;pdesc->ppOperationKind[hr][slen]!=AS_END_ARRAY;slen++);//߂̎ނ𐔂B
		slen++;
		m_ppOpeStrKind[r] = new __int64[slen];
		memcpy(m_ppOpeStrKind[r] , pdesc->ppOperationKind[hr] , sizeof(__int64)*slen);//I[܂ŃRs[B

		m_pOpeLen[r] = pOpeLen[hr];

		//̕̕ѕۑĂB
		m_pOrgOpeMap[hr] = r;//tϊ}bvB
	}

	//z̏I[B
	m_pOpeLen[nOpe] = 0;
	m_pOpeStr[nOpe]      = 0;
	m_ppOpeStrKind[nOpe]  = 0;

	memcpy(m_pOpeMap , pPriMap , sizeof(__int64)*nOpe);
	//̊JB

	
	delete [] pPriMap;
	delete [] pOpeLen;

	//AZu̕B
	m_isNum = pdesc->asmEnableNumber;
	m_isStr = pdesc->asmEnableString;
	if(m_isStr)
	{
		slen = pdesc->Asd.nStrBlockSet;
		slen++;
		m_pStringStart = new wchar_t*[slen];
		m_pStringEnd   = new wchar_t*[slen];
		slen--;
		m_pStringEnd[slen] = 0;
		m_pStringStart[slen] = 0;

		

		for(__int64 r=0;r<slen;r++)
		{
			hr = wcslen(pdesc->Asd.pStrBlockStart[r]);
			hr++;
			m_pStringStart[r] = new wchar_t[hr];
			memcpy(m_pStringStart[r] , pdesc->Asd.pStrBlockStart[r] , sizeof(wchar_t)*hr);

			hr = wcslen(pdesc->Asd.pStrBlockEnd[r]);
			hr++;
			m_pStringEnd[r] = new wchar_t[hr];
			memcpy(m_pStringEnd[r] , pdesc->Asd.pStrBlockEnd[r] , sizeof(wchar_t)*hr);
		}

		slen = pdesc->Asd.nTransSet;
		slen++;
		m_pTransStr   = new wchar_t*[slen];
		m_pTransToStr = new wchar_t*[slen];
		slen--;
		m_pTransStr[slen] = 0;
		m_pTransToStr[slen] = 0;

		for(__int64 r=0;r<slen;r++)
		{
			hr = wcslen(pdesc->Asd.pTransStr[r]);
			hr++;
			m_pTransStr[r] = new wchar_t[hr];
			memcpy(m_pTransStr[r] , pdesc->Asd.pTransStr[r] , sizeof(wchar_t)*hr);

			hr = wcslen(pdesc->Asd.pTransToStr[r]);
			hr++;
			m_pTransToStr[r] = new wchar_t[hr];
			memcpy(m_pTransToStr[r] , pdesc->Asd.pTransToStr[r] , sizeof(wchar_t)*hr);
		}

		hr = 0;
		for(__int64 r=0;m_pTransStr[r]!=0;r++)
		{
			slen = wcslen(m_pTransStr[r]);
			if(slen>hr)
			{
				hr = slen;
			}
		}
		for(__int64 r=0;m_pTransToStr[r]!=0;r++)
		{
			slen = wcslen(m_pTransToStr[r]);
			if(slen>hr)
			{
				hr = slen;
			}
		}

		m_MaxLenTransStr = hr;
	}

	m_cDistSize = 0;

	
	//B
	m_isInit = true;
	return 0;
}
__int64 CScriptAnalizer::AsmSetAssenblyPoint(__int64 c)
{
	if(c>m_nAsmCode)

	{
		return -1;
	}
	if(c<0)
		return -2;

	m_cAsm = c;
	return 0;
}

__int64 CScriptAnalizer::Analize(ANALIZE_DESC* pAd)
{
	bool isHit;
	__int64 slen;
	__int64 nOpe;
	wchar_t* pCodeBuff;
	//NULL|C^`FbNB
	if(pAd==0)
	{
		return -99;
	}
	if(!m_isInit)
	{
		swprintf_s(m_errmsg , 200 , L"XNvg̓NXꂸɎgp܂B" , pAd->pCode);
		return -3;
	}
	if(pAd->pCode==0)
	{
		swprintf_s(m_errmsg , 200 , L"XNvg̓NXɖȃR[h̃|C^[n܂B%s", pAd->pCode);
		return -1;
	}
	if(pAd->nCode<=0)
	{
		swprintf_s(m_errmsg , 200 , L"XNvg̓NXɓnꂽ̒łB%d" , pAd->nCode);
		return -2;
	}
	
	
	pCodeBuff = new wchar_t[pAd->nCode + m_pOpeLen[0] + 5];//\`FbN̂߂ɗ]ɎĂB
	//̃f[^ςȂ悤ɃRs[B
	memcpy(pCodeBuff , pAd->pCode , sizeof(wchar_t)*pAd->nCode);
	//]vȓȂ悤ɂ܂0Ŗ߂ĂB
	memset(pCodeBuff + pAd->nCode , 0 ,  sizeof(wchar_t)*(m_pOpeLen[0]+2));

	__int64 OperatorCount;
	__int64 OperandPos[MAX_OPERAND_COUNT][2];
	__int64 OperandCount;
	__int64 LockK;


	__int64 LockOpe;
	__int64 kOpe;
	__int64 cClum;//݂̍sB

	bool isOperationFinished;
	bool isOperand;
	__int64 isLock;//Y߂܂łق̖߂NȂB

	for(__int64 i=0;i<MAX_OPERAND_COUNT;i++)
	{
		OperandPos[i][0]=0;
		OperandPos[i][1]=0;
	}
	pAd->nAsmCode         = 0;
	isOperand             = 0;
	isOperationFinished   = false;
	OperatorCount         = 0;
	OperandCount          = 0;
	cClum                 = 0;
	isLock                = 0;
	

	nOpe=0;
	//܂͖߂̐𐔂BAS_OPERATION_END̂ƂłB
	for(__int64 i=0;i<pAd->nCode;)
	{
		//Y镶񂪂邩ǂ`FbNĂB
		//͗\̃`FbNłB
		for(__int64 j=0;m_pOpeStr[j]!=0;j++)
		{
			//̑\[gĂ͂łB
			isHit = true;
			for(__int64 k=0;k<m_pOpeLen[j];k++)
			{
				if(m_pOpeStr[j][k]==pCodeBuff[i + k])
					continue;//̕`FbNB

				isHit = false;
				break;
			}
			if(!isHit)//Y\ꂪȂB
				continue;//B


			for(__int64 k=0;m_ppOpeStrKind[j][k] != AS_END_ARRAY;k++)//񂪕̈ӖƂB
			{
				kOpe = m_ppOpeStrKind[j][k];
				switch(kOpe)
				{
				case  AS_OPERATION_END:
					nOpe++;
					break;
				default:
					break;
				}
			}
			
			//Z͓̕܂łĂB
			i+=m_pOpeLen[j];
			if(i >= pAd->nCode)
			{
				break;
			}
			j=-1;
		}
		//ʏ̕ƂďB
		i++;
	}

	//ߐmۂB
	m_pAsmCode = new ASM_CODE_DESC[nOpe+2];
	m_nAsmCode = nOpe;

	memset(m_pAsmCode , 0 , sizeof(ASM_CODE_DESC)*nOpe);


	

	

	for(__int64 h=0;h<pAd->nCode;)
	{
		//Y镶񂪂邩ǂ`FbNĂB
		//͗\̃`FbNłB

		for(__int64 j=0;m_pOpeStr[j]!=0;j++)
		{
			//̑\[gĂ͂łB
			isHit = true;
			if(h>pAd->nCode)
				goto SAFE_END;

			for(__int64 k=0;k<m_pOpeLen[j];k++)
			{
				if(m_pOpeStr[j][k]==pCodeBuff[h + k])
					continue;//̕`FbNB

				isHit = false;
				break;
			}
			if(!isHit)//Y\ꂪȂB
				continue;//B

			if(isLock==1)
			{
				if( LockK == j)
				{
					isLock = 2;
				}
				else
				{
					if(h >= pAd->nCode)
					{
						//ɃubNIR}h𔭍sB
						kOpe = LockOpe;
						isLock = 2;
					}
				}
			}

			if(isLock==1)
			{
				break;
			}


			for(__int64 k=0;k<m_ppOpeStrKind[j][k]!=AS_END_ARRAY;k++)
			{
				kOpe = m_ppOpeStrKind[j][k];
				
				switch(kOpe)
				{
				case AS_WORDBREAK:
					cClum++;
					break;
				case  AS_BLOCK_START:
					if(OperatorCount!=0)
						m_pAsmCode[OperatorCount-1].isStac++;
					break;
				case  AS_BLOCK_END:
					if(OperatorCount!=0)
					m_pAsmCode[OperatorCount-1].isStac--;
					break;
				case  AS_OPERATION_END:
					if(isOperand)
					{
						OperandPos[OperandCount][1] = h;
						OperandCount++;
						if(OperandCount > MAX_OPERAND_COUNT)
						{
							swprintf_s(m_errmsg , 200 , L"G[@: %dsځBIyh̐łBGĂ܂H" , cClum+1);
							goto ERR_END;
						}
						isOperand = false;
					}
					isOperationFinished  = true;
					break;
				case  AS_ESCAPEBLOCK_START:
					if(isLock==2)
					{
						//AS_ESCAPEBLOCK_ENDƓ蓖ĂĂꍇɔB
						break;
					}

					isLock = 1;
					LockOpe = AS_ESCAPEBLOCK_END;
					LockK  = m_pOrgOpeMap[m_ppOpeStrKind[j][k+1] - AS_BLOCKWORD_ENTRY];

					if(isOperand)
					{
						OperandPos[OperandCount][1] = h;
						OperandCount++;
						if(OperandCount >= MAX_OPERAND_COUNT)
						{
							swprintf_s(m_errmsg , 200 , L"G[@: %dsځBIyh̐łBGĂ܂H" , cClum+1);
							goto ERR_END;
						}
						isOperand  = false;
					}
					break;
				case  AS_ESCAPEBLOCK_END:

					break;
				case  AS_RESERVED_WORD:
					if(isOperand)
					{
						OperandPos[OperandCount][1] = h;
						OperandCount++;
						if(OperandCount >= MAX_OPERAND_COUNT)
						{
							swprintf_s(m_errmsg , 200 , L"G[@: %dsځBIyh̐łBGĂ܂H" , cClum+1);
							goto ERR_END;
						}
						isOperand = false;
					}
					OperandPos[OperandCount][0] = h;
					OperandPos[OperandCount][1] = h + m_pOpeLen[j];
					OperandCount++;
					if(OperandCount >= MAX_OPERAND_COUNT)
					{
						swprintf_s(m_errmsg , 200 , L"G[@: %dsځBIyh̐łBGĂ܂H" , cClum+1);
						return -1;
					}

					break;
				case AS_SPACE_WORD:
					if(isOperand)
					{
						OperandPos[OperandCount][1] = h;
						OperandCount++;
						if(OperandCount >= MAX_OPERAND_COUNT)
						{
							swprintf_s(m_errmsg , 200 , L"G[@: %dsځBIyh̐łBGĂ܂H" , cClum+1);
							goto ERR_END;
						}
						isOperand  = false;
					}
					break;
				case AS_STRING_START:
					if(isLock==2)
					{
						//AS_STRING_ENDƓ蓖ĂĂꍇɔB
						break;
					}

					isLock = 1;
					LockK  = m_pOrgOpeMap[m_ppOpeStrKind[j][k+1] - AS_BLOCKWORD_ENTRY];
					LockOpe = AS_STRING_END;

					if(isOperand)
					{
						OperandPos[OperandCount][1] = h;
						OperandCount++;
						if(OperandCount >= MAX_OPERAND_COUNT)
						{
							swprintf_s(m_errmsg , 200 , L"G[@: %dsځBIyh̐łBGĂ܂H" , cClum+1);
							return -1;
						}
						isOperand = true;
					}
					OperandPos[OperandCount][0] = h;
					break;
				case AS_STRING_END:
					if(isLock==2)
					{
						OperandPos[OperandCount][1] = h + m_pOpeLen[j];
						OperandCount++;
						isOperand = false;
					}
					break;
				default:
					break;
				}
			}
			h += m_pOpeLen[j];
			j=-1;//̂Ōɖ߂B

			if(isLock==2)
			{
				isLock=0;
			}

			if(!isOperationFinished)
				continue;

			//߂̋؂肪ĂB
			if(OperandCount==0)
			{
				isOperationFinished = false;
				isOperand           = false;
				OperandCount   = 0;
				continue;
			}
			
			m_pAsmCode[OperatorCount].opetex = new wchar_t*[OperandCount+1];
			for(__int64 i=0;i<OperandCount;i++)
			{
				slen = OperandPos[i][1]-OperandPos[i][0];
				m_pAsmCode[OperatorCount].opetex[i] = new wchar_t[slen+1];
				memcpy(m_pAsmCode[OperatorCount].opetex[i] , pCodeBuff + OperandPos[i][0] , slen*sizeof(wchar_t));
				m_pAsmCode[OperatorCount].opetex[i][slen]=0;
			}

			m_pAsmCode[OperatorCount].opetex[OperandCount] = 0;
			

			
			m_pAsmCode[OperatorCount].clum = cClum;//fobN悤ɍsL^ĂB
			isOperationFinished = false;
			OperandCount   = 0;

			OperatorCount++;
			pAd->nAsmCode++;
			
			

			isOperationFinished=false;

		
			
		}

		//ʏ̎ʎqB
		if(!isOperand && isLock==0)
		{
			OperandPos[OperandCount][0] = h;
			isOperand = true;
		}
		h++;
	}
SAFE_END:
	pAd->pAsmCode = m_pAsmCode;
	m_nAsmCode = pAd->nAsmCode;
	if(m_pAsmStrBuff!=0)
	{
		for(__int64 r=0;r<m_cAsmStrBuff;r++)
		{
			if(m_pAsmStrBuff[r] !=0)
			{
				delete [] m_pAsmStrBuff[r];
				m_pAsmStrBuff[r]=0;
			}
		}
		delete [] m_pAsmStrBuff;
		m_pAsmStrBuff=0;
	}

	if(m_AsmStrBuffStrIndex!=0)
	{
		delete [] m_AsmStrBuffStrIndex;
		m_AsmStrBuffStrIndex=0;
	}
	if(m_AsmStrBuffcAsmIndex!=0)
	{
		delete [] m_AsmStrBuffcAsmIndex;
		m_AsmStrBuffcAsmIndex=0;
	}

	m_pAsmStrBuff = new wchar_t*[DEFAULT_STRBUFF_EXTENTION];
	m_AsmStrBuffcAsmIndex = new __int64[DEFAULT_STRBUFF_EXTENTION];
	m_AsmStrBuffStrIndex  = new __int64[DEFAULT_STRBUFF_EXTENTION];
	m_nAsmStrBuff = DEFAULT_STRBUFF_EXTENTION;
	m_cAsmStrBuff = 0;

	m_isCompile=true;
	delete [] pCodeBuff;
	return 0;
ERR_END:
	delete [] pCodeBuff;
	if(m_pAsmCode!=0)
	{
		if(m_nAsmCode>0)
		{
			for(__int64 r=0;r<m_nAsmCode;r++)
			{
				if(m_pAsmCode->opetex!=0)
				{
					for(__int64 j=0;m_pAsmCode->opetex[j]!=0;j++)
					{
						delete [] m_pAsmCode->opetex[j];
						m_pAsmCode->opetex[j]=0;
					}
					delete [] m_pAsmCode->opetex;
					m_pAsmCode->opetex=0;
				}
			}
		}
		delete [] m_pAsmCode;
		m_pAsmCode=0;
	}
	return -2;
}

__int64 CScriptAnalizer::Release()
{
	if(m_pOpeStr!=0)
	{
		for(__int64 x=0;m_pOpeStr[x]!=0;x++)
		{
			if(m_pOpeStr[x]!=0)
			{
				delete [] m_pOpeStr[x];
				m_pOpeStr[x]=0;
			}
		}
		delete [] m_pOpeStr;
		m_pOpeStr=0;
	}
	if(m_ppOpeStrKind!=0)
	{
		for(__int64 r=0;m_ppOpeStrKind[r]!=0;r++)
		{
			if(m_ppOpeStrKind[r]!=0)
			{
				delete [] m_ppOpeStrKind[r];
				m_ppOpeStrKind[r]=0;
			}
		}
		delete [] m_ppOpeStrKind;
		m_ppOpeStrKind=0;
	}

	if(m_pOpeLen!=0)
	{
		delete [] m_pOpeLen;
		m_pOpeLen=0;
	}

	if(m_pOrgOpeMap!=0)
	{
		delete [] m_pOrgOpeMap;
		m_pOrgOpeMap=0;
	}
	if(m_pOpeMap!=0)
	{
		delete [] m_pOpeMap;
		m_pOpeMap = 0;
	}

	if(m_pAsmCode!=0)
	{
		if(m_nAsmCode>0)
		{
			for(__int64 r=0;r<m_nAsmCode;r++)
			{
				if(m_pAsmCode->opetex!=0)
				{
					for(__int64 j=0;m_pAsmCode->opetex[j]!=0;j++)
					{
						delete [] m_pAsmCode->opetex[j];
						m_pAsmCode->opetex[j]=0;
					}
					delete [] m_pAsmCode->opetex;
					m_pAsmCode->opetex=0;
				}
			}
		}
		delete [] m_pAsmCode;
		m_pAsmCode=0;
	}

	if(m_pStringStart!=0)
	{
		for(__int64 r=0;m_pStringStart[r]!=0;r++)
		{
			delete [] m_pStringStart[r];
			m_pStringStart[r]=0;
		}

		delete m_pStringStart;
		m_pStringStart=0;
	}
	if(m_pStringEnd!=0)
	{
		for(__int64 r=0;m_pStringEnd[r]!=0;r++)
		{
			delete [] m_pStringEnd[r];
			m_pStringEnd[r]=0;
		}

		delete m_pStringEnd;
		m_pStringEnd=0;
	}
	if(m_pTransStr!=0)
	{
		for(__int64 r=0;m_pTransStr[r]!=0;r++)
		{
			delete [] m_pTransStr[r];
			m_pTransStr[r]=0;
		}

		delete m_pTransStr;
		m_pTransStr=0;
	}
	if(m_pTransToStr!=0)
	{
		for(__int64 r=0;m_pTransToStr[r]!=0;r++)
		{
			delete [] m_pTransToStr[r];
			m_pTransToStr[r]=0;
		}

		delete m_pTransToStr;
		m_pTransToStr=0;
	}


	m_isNum = false;
	m_isStr = false;
	m_isCompile = false;
	m_isInit = false;

	if(m_pDistStr!=0)
	{
		for(__int64 r=0;r<m_cDist;r++)
		{
			if(m_pDistStr[r]!=0)
			{
				delete [] m_pDistStr[r];
				m_pDistStr[r]=0;
			}
		}

		delete m_pDistStr;
		m_pDistStr=0;
	}
	if(m_pDistLength!=0)
	{
		delete [] m_pDistLength;
		m_pDistLength=0;
	}
	if(m_phDist!=0)
	{
		delete [] m_phDist;
		m_phDist=0;
	}

	if(m_pAsmStrBuff!=0)
	{
		for(__int64 r=0;r<m_cAsmStrBuff;r++)
		{
			if(m_pAsmStrBuff[r] !=0)
			{
				delete [] m_pAsmStrBuff[r];
				m_pAsmStrBuff[r]=0;
			}
		}
		delete [] m_pAsmStrBuff;
		m_pAsmStrBuff=0;
	}

	if(m_AsmStrBuffStrIndex!=0)
	{
		delete [] m_AsmStrBuffStrIndex;
		m_AsmStrBuffStrIndex=0;
	}
	if(m_AsmStrBuffcAsmIndex!=0)
	{
		delete [] m_AsmStrBuffcAsmIndex;
		m_AsmStrBuffcAsmIndex=0;
	}
	return 0;
}
__int64 CScriptAnalizer::AdAsmDistinction(const wchar_t* pDistStr , __int64 k)
{
	__int64 *pdlbuff;
	__int64 *pdnbuff;
	wchar_t  **pdsbuff;
	__int64 slen;

	
	if(m_cDistSize <= m_cDist)
	{
		//f[^ޔB
		pdsbuff = m_pDistStr;
		pdnbuff = m_phDist;
		pdlbuff = m_pDistLength;

		m_cDistSize +=DEFAULT_DIST_BLOCK;

		m_pDistStr = new wchar_t*[m_cDistSize];
		m_phDist = new __int64[m_cDistSize];
		m_pDistLength = new __int64[m_cDistSize];

		memcpy(m_pDistStr , pdsbuff , sizeof(wchar_t*)*m_cDist);
		memcpy(m_phDist , pdnbuff , sizeof(__int64)*m_cDist);
		memcpy(m_pDistLength , pdlbuff , sizeof(__int64)*m_cDist);

		delete [] pdsbuff;
		delete [] pdnbuff;
		delete [] pdlbuff;
	}
	slen = wcslen(pDistStr);
	slen++;
	m_pDistStr[m_cDist] = new wchar_t[slen];
	memcpy(m_pDistStr[m_cDist] , pDistStr , sizeof(wchar_t)*slen);
	m_phDist[m_cDist] = k;
	slen--;
	m_pDistLength[m_cDist] = slen;

	m_cDist++;
	return 0;
}
__int64 CScriptAnalizer::AsmCountDistincions(__int64 hOpe)
{
	__int64 len,c;
	bool isHit;

	c=0;
	isHit = false;
	for(__int64 r=0;r<m_cDist;r++)
	{
		if(m_phDist[r] == hOpe)
		{
			isHit = true;
			hOpe = r;
			break;
		}
	}

	if(!isHit)
		return -1;//݂܂B

	for(__int64 i=0;i<m_nAsmCode;i++)
	{
		for(__int64 r=0;m_pAsmCode[i].opetex[r]!=0;r++)
		{
			len = wcslen(m_pAsmCode[i].opetex[r]);

			if(len != m_pDistLength[hOpe])//ԈĂB
				continue;

			isHit=true;
			for(__int64 j=0;j<len;j++)
			{
				if(m_pDistStr[hOpe][j] != m_pAsmCode[i].opetex[r][j])
				{
					isHit = false;
					break;
				}

			}
			if(isHit)
			{
				c++;
			}
		}
		
	}
	return c;
}
__int64 CScriptAnalizer::AsmGetNextAssembly(EXE_ASMCODE_DESC* pEad)//ʎq߂܂BĂяoтɃJEgCNg܂B
{
	__int64 slen,slen2,slen3,slen4,c;
	__int64 creg;
	__int64 qw0;
	__int64 dotpos;
	__int64 dotpos2;
	__int64 Epos;
	__int64 isEminus;
	__int64 *pIntBuff;
	wchar_t* pStrBuff,*pStrBuff2;
	wchar_t** pAsmStrBuff;
	double DoubleBuff,DoubleBuff2,db2;//ꎞϐB
	bool isDot;//_B
	bool is16;//16iB
	bool isHit;
	if(!m_isCompile)
	{
		swprintf_s(m_errmsg ,MAX_ERRMESSAGE  , L"CScriptAnalizerIuWFNg : ͂ɃAZuN܂B");
		return -1;
	}
	if(!m_isInit)
	{
		swprintf_s(m_errmsg ,MAX_ERRMESSAGE  , L"CScriptAnalizerIuWFNg : ꂸɎgp܂B");
		return -1;
	}
	if(m_cAsm == m_nAsmCode)
	{
		swprintf_s(m_errmsg ,MAX_ERRMESSAGE  , L"CScriptAnalizerIuWFNg : ɏI");
		return 1;//ŏIɒB܂B
	}
	//̉ǁB
	pEad->stac = m_pAsmCode[m_cAsm].isStac;
	pEad->clum = m_pAsmCode[m_cAsm].clum;

	creg = 0;
	for(__int64 i=0;m_pAsmCode[m_cAsm].opetex[i]!=0;i++)
	{
		pEad->str[i] = m_pAsmCode[m_cAsm].opetex[i];
	}
	for(__int64 i=0;m_pAsmCode[m_cAsm].opetex[i]!=0;i++)
	{
		slen = wcslen(m_pAsmCode[m_cAsm].opetex[i]);

		if(creg >= MAX_REGISTER)
		{
			swprintf_s(m_errmsg ,MAX_ERRMESSAGE  , L"CScriptAnalizerIuWFNg : ߂G܂Bߋ؂tYĂ܂񂩁H");
			goto ERR_END;
		}

		for(__int64 j=0;j<m_cDist;j++)
		{
			if(creg >= MAX_REGISTER)
			{
				swprintf_s(m_errmsg ,MAX_ERRMESSAGE  , L"CScriptAnalizerIuWFNg : ߂G܂Bߋ؂tYĂ܂񂩁H");
				goto ERR_END;
			}
			if(m_pDistLength[j] != slen)
			{
				//炵ĊԈĂB
				continue;
			}
			isHit=true;

			for(__int64 k=0;k<slen;k++)
			{
				if(m_pDistStr[j][k] != m_pAsmCode[m_cAsm].opetex[i][k])
				{
					isHit = false;
					break;
				}
			}

			if(!isHit)//qbgȂB
				continue;

			//JԂB
			

			pEad->kreg[creg] = m_phDist[j];
			pEad->reg[creg]  = 0;
			j=-1;//߂͂߂炳B
			creg++;//̃CfbNX
			i++;//̕
			if(m_pAsmCode[m_cAsm].opetex[i]==0)//I[łȂ`FbNB
				goto SAFE_END;

			slen = wcslen(m_pAsmCode[m_cAsm].opetex[i]);
		}
		//`ĂȂB

		isHit = false;
		if(m_isStr)//ϊT|[g邩ǂB
		{
			isHit =false;
			for(__int64 r=0;r<m_cAsmStrBuff;r++)
			{
				if(m_AsmStrBuffcAsmIndex[r] != m_cAsm)
					continue;
				if(m_AsmStrBuffStrIndex[r] != i)
					continue;
					
				//v̂B
				pEad->reg[creg] = m_pAsmStrBuff[r];
				pEad->kreg[creg] = ASM_IMM_STR;

				creg++;
				isHit = true;
				break;
			}

			if(isHit)

				continue;
			
			isHit =false;
			for(__int64 j=0;m_pStringStart[j]!=0;j++)//擪ƁAŌ̕`FbNB
			{
				
				slen2 = wcslen(m_pStringStart[j]);
				slen3 = wcslen(m_pStringEnd[j]);
				if(slen < slen2+slen3)//肦ȂB
				{
					continue;//قB
				}

				//񂪎܂邾̑傫͂B

				isHit = true;
				//擪`FbNB
				for(__int64 k=0;k<slen2;k++)
				{
					if(m_pStringStart[j][k]!=m_pAsmCode[m_cAsm].opetex[i][k])
					{
						isHit = false;
						break;
					}
				}

				if(!isHit)
					continue;//擪ĂȂB

				for(__int64 k=slen-1,w=slen3-1;w>=0;)
				{
					if(m_pStringStart[j][w]!=m_pAsmCode[m_cAsm].opetex[i][k])
					{
						isHit = false;
						break;
					}
					k--;
					w--;
				}
				if(!isHit)
					continue;//ĂȂB

				//ĂBƂĔFB
				qw0 = j;
				break;
			}

			if(isHit)
			{
				slen4 = slen;
				slen4++;
				pStrBuff = new wchar_t[slen4];
				//ǂݎȂ悤ɂB
				slen -=slen3;
				//ƂďB
				//uKĂB
				c=0;
				for(__int64 j=slen2;j<slen;)
				{
					for(__int64 k=0;m_pTransStr[k]!=0;k++)
					{
						slen2 = wcslen(m_pTransStr[k]);
						isHit = true;
						for(__int64	q=0; q<slen2;q++)
						{
							if(q+j >= slen)
							{
								isHit =false;
								break;
							}
							if(m_pAsmCode[m_cAsm].opetex[i][j+q] != m_pTransStr[k][q])
							{
								isHit =false;
								break;
							}
						}

						if(!isHit)
							continue;

						//񂪃qbgB
						slen3 = wcslen(m_pTransToStr[k]);
						if(slen4<=c + slen3)//obt@ȂB
						{
							//gBƒxȂ̂ŗ]ɎĂB
							pStrBuff2 = pStrBuff;
							pStrBuff = new wchar_t[c + slen3 + 20];//xŕK悤ɊmۂB
							memcpy(pStrBuff , pStrBuff2 , sizeof(wchar_t)*slen4);
							slen4 = c + slen3 + 20;
							delete [] pStrBuff2;
						}
						memcpy(pStrBuff + c , m_pTransToStr[k] , sizeof(wchar_t)*slen3);
						c+=slen3;
						j+=slen2;
						//ēxʎqB
						k=-1;
					}
					//ʏ̕B
					if(slen4<=c)//obt@ȂB
					{
						//gBƒxȂ̂ŗ]ɎĂB
						pStrBuff2 = pStrBuff;
						pStrBuff = new wchar_t[c+ 20];
						memcpy(pStrBuff , pStrBuff2 , sizeof(wchar_t)*slen4);
						slen4 = c+ 20;
						delete [] pStrBuff2;
					}
					pStrBuff[c] = m_pAsmCode[m_cAsm].opetex[i][j];
					c++;
					j++;
				}
				if(slen4<=c)//obt@ȂB
				{
					
					pStrBuff2 = pStrBuff;
					pStrBuff = new wchar_t[slen4 + 1];
					memcpy(pStrBuff , pStrBuff2 , sizeof(wchar_t)*slen4);
					slen4 = slen4 + 1;
					delete [] pStrBuff2;
				}
				pStrBuff[c]=0;

				if(m_cAsmStrBuff >= m_nAsmStrBuff)
				{
					//̃obt@TCYޔ
					slen2 = m_nAsmStrBuff;
					m_nAsmStrBuff+=DEFAULT_STRBUFF_EXTENTION;

					pAsmStrBuff = m_pAsmStrBuff;

					m_pAsmStrBuff = new wchar_t*[m_nAsmStrBuff];
					memcpy(m_pAsmStrBuff , pAsmStrBuff , sizeof(wchar_t*)*slen2);
					delete [] pAsmStrBuff;

					pIntBuff = m_AsmStrBuffcAsmIndex;
					m_AsmStrBuffcAsmIndex = new __int64[m_nAsmStrBuff];
					memcpy(m_AsmStrBuffcAsmIndex , pIntBuff , sizeof(__int64)*slen2);
					delete [] pIntBuff;

					pIntBuff = m_AsmStrBuffStrIndex;
					m_AsmStrBuffStrIndex = new __int64[m_nAsmStrBuff];
					memcpy(m_AsmStrBuffStrIndex , pIntBuff , sizeof(__int64)*slen2);
					delete [] pIntBuff;
				}

				//NXJ邽߂ɕ̃|C^ێĂB
				m_pAsmStrBuff[m_cAsmStrBuff] = pStrBuff;

				//Qxڂ̏ZkB
				m_AsmStrBuffcAsmIndex[m_cAsmStrBuff] = m_cAsm;
				m_AsmStrBuffStrIndex[m_cAsmStrBuff] = i;

				m_cAsmStrBuff++;

				pEad->reg[creg]  = pStrBuff;
				pEad->kreg[creg] = ASM_IMM_STR;

				creg++;
				isHit = true;
			}
		}
		if(isHit)//ɏꂽB
			continue;

		if(m_isNum)//lϊT|[g邩ǂB
		{
			is16 = false;

			if(m_pAsmCode[m_cAsm].opetex[i][0] == L'0' && (m_pAsmCode[m_cAsm].opetex[i][1]==L'x' || m_pAsmCode[m_cAsm].opetex[i][1]==L'X') )//16iƂďB
			{
				is16 = true;
			}
	
			
			if(is16)//RT|[gȂB
			{
				qw0=0;
				for(__int64 k=2;k<slen;k++)
				{
					qw0 *= 16;
					if(m_pAsmCode[m_cAsm].opetex[i][k] >=  L'0' &&  m_pAsmCode[m_cAsm].opetex[i][k] <=  L'9')
					{
						qw0 += m_pAsmCode[m_cAsm].opetex[i][k]-L'0';
						continue;
					}

					if(m_pAsmCode[m_cAsm].opetex[i][k] >=  L'a' &&  m_pAsmCode[m_cAsm].opetex[i][k] <=  L'f')
					{
						qw0 += m_pAsmCode[m_cAsm].opetex[i][k]-L'a';
						continue;
					}
					if(m_pAsmCode[m_cAsm].opetex[i][k] >=  L'A' &&  m_pAsmCode[m_cAsm].opetex[i][k] <=  L'F')
					{
						qw0 += m_pAsmCode[m_cAsm].opetex[i][k]-L'A';
						continue;
					}

					//̕B
					isHit = false;
					break;
				}
				//IB
				if(isHit)
				{
					//B
					pEad->kreg[creg] = ASM_IMM_INT;
					m_eadint[creg]   = qw0;
					pEad->reg[creg]  = m_eadint + creg;
					creg++;
				}
			}
			else
			{

				//ʏ̐l
				isDot = false;
				dotpos = slen;
				dotpos2 = slen;
				Epos    = slen;
				isHit = true;
				isEminus = 0;
				//܂͐l`ǂB_̈ʒuAẅʒu𒲂ׂB
				for(__int64 k=0;k<slen;k++)
				{
					if(m_pAsmCode[m_cAsm].opetex[i][k] == L'.')
					{
						isDot = true;
						if(dotpos == slen)
						{
							dotpos = k;
						}

						if(dotpos2 == slen - Epos-1-isEminus)
						{
							dotpos2 = k - Epos-1-isEminus;
						}
					}
					else if(m_pAsmCode[m_cAsm].opetex[i][k] == L'E' || m_pAsmCode[m_cAsm].opetex[i][k] == L'e')
					{
						isDot = true;
						if(m_pAsmCode[m_cAsm].opetex[i][k+1] == 'i' || m_pAsmCode[m_cAsm].opetex[i][k+1] == 'I')
						{
							//]
							isEminus = 1;
						}
						Epos = k;
						if(dotpos == slen)
							dotpos = Epos;
						dotpos2 = slen - Epos-1-isEminus;

						if(isEminus == 1)
							k++;
					}
					else if(m_pAsmCode[m_cAsm].opetex[i][k] < L'0' || L'9'<m_pAsmCode[m_cAsm].opetex[i][k])//lł͂ȂB
					{
						isHit = false;
						break;
					}
				}
				if(isHit)
				{
					
					if(isDot)
					{
						DoubleBuff=0;
						//vZB
						dotpos--;
						for(__int64 k=0;k<Epos;k++)
						{
							if(m_pAsmCode[m_cAsm].opetex[i][k] == L'.')
								continue;

							db2 = m_pAsmCode[m_cAsm].opetex[i][k] - L'0';
							DoubleBuff += db2 * powl(10 , dotpos);
							dotpos--;
						}

						DoubleBuff2=0;
						//wvZB
						dotpos2--;
						for(__int64 k=Epos+1+isEminus;k<slen;k++)
						{
							if(m_pAsmCode[m_cAsm].opetex[i][k] == L'.')
								continue;

							db2 = m_pAsmCode[m_cAsm].opetex[i][k] - L'0';
							DoubleBuff2 += db2 * powl(10 , dotpos2);
							dotpos2--;
						}

						pEad->kreg[creg]  = ASM_IMM_DOUBLE;
						m_eaddouble[creg] = DoubleBuff*pow(10 , (1-isEminus*2)*DoubleBuff2);
						pEad->reg[creg]   = m_eaddouble + creg;
						creg++;
					}
					else
					{
						qw0 = 0;
						for(__int64 k=0;k<slen;k++)
						{
							qw0 *= 10;
							qw0 += (__int64)m_pAsmCode[m_cAsm].opetex[i][k] - (__int64)L'0';
						}
						//B
						pEad->kreg[creg]  = ASM_IMM_INT;
						m_eadint[creg]    = qw0;
						pEad->reg[creg]   = m_eadint + creg;;
						creg++;
					}
				}
			}
		}
		if(isHit)
			continue;//ɏꂽB
		
		//`̎ʎqB
		pEad->kreg[creg] = ASM_UNKNOWN;
		m_eadint[creg]   = slen;
		pEad->reg[creg]  = m_eadint + creg;;
		creg++;
	}
	
SAFE_END:
	m_cAsm++;
	pEad->creg = creg;
	return 0;
ERR_END:
	m_cAsm++;
	pEad->creg = MAX_REGISTER;
	return -1;
}

wchar_t* CScriptAnalizer::GetLastErr()
{
	bool isHit;
	isHit = false;
	for(__int64 r=0;r<MAX_ERRMESSAGE;r++)
	{
		if(m_errmsg[r] == 0)
		{
			isHit = true;
		}
	}
	if(!isHit)
	{
		swprintf_s(m_errmsg , MAX_ERRMESSAGE , L"No err occurred");
	}
	
	return m_errmsg;
}
CScriptAnalizer::~CScriptAnalizer(void)
{
} 
