#pragma once
//Version 3.2.0 2013/9/27
//IȃXNvgARpC@\񋟂܂B
//ȂȂŃoOقڂȂ肵Ă܂B
//C,C++,Java,CSVȂǂ̃eLXgt@C\ǂł܂B
//RpCȂǂɗpĂB

#define MAX_OPERAND_COUNT 100
#define MAX_ESCAPE_COUNT 30
#define COMPILE_DEFINE 0
#define COMPILE_INCLUDE 1

#define AS_END_ARRAY 0
#define AS_NORMAL_WORD 1
#define AS_BLOCK_START 2
#define AS_BLOCK_END   3
#define AS_OPERATION_END 4
#define AS_ESCAPEBLOCK_START 5
#define AS_ESCAPEBLOCK_END 6
#define AS_RESERVED_WORD 7
#define AS_SPACE_WORD 8
#define AS_STRING_START 9
#define AS_STRING_END 10
#define AS_WORDBREAK 13

#define AS_BLOCKWORD_ENTRY 0xffffff


#define ASM_USER 0xffff          //[U[`̎ʎq
#define ASM_STRING_START 16      //Jn̎ʎq
#define ASM_STRING_END   17      //I̎ʎqB
#define ASM_UNKNOWN 18           //̎ʎqB
#define ASM_IMM_INT   19         //INT ^̎ʎq
#define ASM_IMM_DOUBLE 38        //_u^̎ʎq
#define ASM_IMM_STR   21         //^̎ʎm
#define ASM_EQ 22             
#define ASM_MOV 23
#define ASM_EQLESS 24
#define ASM_EQMORE 25
#define ASM_EQLESS2 26
#define ASM_EQMORE2 27
#define ASM_LESS 28
#define ASM_MORE 29
#define ASM_BRACKETS_START 30
#define ASM_BRACKETS_CLOSE 31
#define ASM_ADD 32
#define ASM_MUL 33
#define ASM_SUB 34
#define ASM_DIV 35
#define ASM_REG 36
#define ASM_END 37


#define MAX_REGISTER 100
struct EXE_ASMCODE_DESC
{
	void* reg[MAX_REGISTER];
	wchar_t* str[MAX_REGISTER];
	__int64 kreg[MAX_REGISTER];//WX^ށB
	__int64 creg;
	__int64 clum;
	__int64 stac;
};
	
struct COMPILE_SUB_DESC{
	__int64 kreg[30][8];
	__int64 reg[30][8];
	__int64 creg[30];
	__int64 nOpe;
	__int64 clum;
	EXE_ASMCODE_DESC *in;
	wchar_t err[200];
};

struct COMPILE_BUFF_DESC
{
	__int64* kreg;
	__int64* reg;
	__int64 creg;
};

// Cxgt@CRpC܂B
struct ASM_CODE_DESC{
	wchar_t** opetex;
	__int64 isStac;
	__int64 clum;
};

struct ASM_STRING_ATTRIBUTE_DESC
{
	wchar_t** pStrBlockStart;//Jn鎯ʎq
	wchar_t** pStrBlockEnd;  //I鎯ʎqB
	__int64 nStrBlockSet;  //񎯕ʎq̐B

	wchar_t** pTransStr;  //ϊB͑Oɕϊ镶
	wchar_t** pTransToStr;//ϊ̕
	__int64 nTransSet;  //ϊ\̐
};
struct INITIALIZE_INFO_DESC
{
	wchar_t** ppOperation;//߂̕ւ̔z
	__int64** ppOperationKind;//߂̎

	bool asmEnableNumber;//lϊ܂B}CiXL\񂳂܂B
	bool asmEnableString;//𐶐܂B
	ASM_STRING_ATTRIBUTE_DESC Asd;//AZu̓w肷B

	/*wchar_t** ppAsmOpeCode;//ϊIyR[hw肵܂B
	__int64** ppAsmOpeCodeKind;//IyR[ḧӖB
	__int64* pOpeCodeNumber;//蓖Ă鎯ʎqB*/
};

#define AD_ERR_STRING_LENGTH 300
struct ANALIZE_DESC
{
	wchar_t* pCode;
	__int64 nCode;
	ASM_CODE_DESC* pAsmCode;
	__int64 nAsmCode;
};

#define DEFAULT_DIST_BLOCK 1
#define DEFAULT_STRBUFF_EXTENTION 1

#define MAX_ERRMESSAGE 500
class CScriptAnalizer
{
private:
	wchar_t** m_pOpeStr;//߂̕ւ̔z
	__int64* m_pOpeLen;//߂̕B
	__int64** m_ppOpeStrKind;//߂̎
	__int64* m_pOrgOpeMap;
	__int64* m_pOpeMap;

	wchar_t m_errmsg[MAX_ERRMESSAGE];
	bool m_isInit;
	ASM_CODE_DESC* m_pAsmCode;
	__int64 m_nAsmCode;

	__int64 m_cAsm;//GetNextAssembly֐Ăяo邽тɃCNg܂B

	wchar_t**  m_pDistStr;
	__int64* m_pDistLength;
	__int64* m_phDist;

	__int64 m_cDistSize;
	__int64 m_cDist;

	bool m_isNum;
	bool m_isStr;
	bool m_isCompile;
	wchar_t** m_pStringStart;
	wchar_t** m_pStringEnd;

	
	wchar_t** m_pTransStr;
	wchar_t** m_pTransToStr;

	__int64 m_MaxLenTransStr;

	wchar_t** m_pAsmStrBuff;
	__int64 m_cAsmStrBuff;
	__int64 m_nAsmStrBuff;

	__int64 *m_AsmStrBuffcAsmIndex;
	__int64 *m_AsmStrBuffStrIndex;

	double m_eaddouble[MAX_REGISTER];
	__int64 m_eadint[MAX_REGISTER];
public:
	__int64 Init(INITIALIZE_INFO_DESC* pdesc);
	__int64 Analize(ANALIZE_DESC* pAd);
	__int64 Release();

	__int64 AdAsmDistinction(const wchar_t* pDistStr , __int64 k);//ʎqǉ܂B
	__int64 AsmCountDistincions(__int64 hOpe);//w肳ꂽԍ̖ߐ𐔂܂B
	__int64 AsmGetNextAssembly(EXE_ASMCODE_DESC* pEad);//ʎq߂܂BĂяoтɃJEgCNg܂B
	__int64 AsmSetAssenblyPoint(__int64 c);
	__int64 AsmCompileFunc(COMPILE_SUB_DESC* lpcsd);
	wchar_t* GetLastErr();
	CScriptAnalizer(void);
	~CScriptAnalizer(void);
};